SCRIPTS
=======

Various scripts for various tasks.

Scripts
-------

  * [backupnaz.sh](https://forge.tourmentine.com/n/scripts/src/master/backupnaz.sh) => used to backup my NAS
  * [cleanmaildir.sh](https://forge.tourmentine.com/n/scripts/src/master/cleanmaildir.sh) => delete old mail in maildirs
  * [dodo.sh](https://forge.tourmentine.com/n/scripts/src/master/dodo.sh) => turn off screen using DPMS
  * [dump_mysql.sh](https://forge.tourmentine.com/n/scripts/src/master/dump_mysql.sh) => dump all mysql databases (and send a report to the monitoring system)
  * [opdsupdates.py](https://forge.tourmentine.com/n/scripts/src/master/opdsupdates.py) => look for OPDS catalog updates and send a mail if any
  * [randomwallpaper.sh](https://forge.tourmentine.com/n/scripts/src/master/randomwallpaper.sh) => display a random wallpaper
  * [secupdate](https://forge.tourmentine.com/n/scripts/src/master/secupdate) => apply security updates & recompile kernel (FreeBSD)
  * [superscreen](https://forge.tourmentine.com/n/scripts/src/master/superscreen) => open multiple ssh sessions to a bunch of servers inside a screen
  * [supertmux](https://forge.tourmentine.com/n/scripts/src/master/supertmux) => open multiple ssh sessions to a bunch of servers inside a tmux
  * [zfsync.sh](https://forge.tourmentine.com/n/scripts/src/master/zfsync.sh) => sync some ZFS pools between two machines

Greasemonkey/Userscripts
------------------------

  * [autocompleteondamnit.user.js](https://forge.tourmentine.com/n/scripts/src/master/userscripts/autocompleteondamnit.user.js) => greasemonkey script for autocomplete on all forms
  * [nickbook.user.js](https://forge.tourmentine.com/n/scripts/src/master/userscripts/nickbook.user.js) => greasemonkey script for facebook
  * [rue89.user.js](https://forge.tourmentine.com/n/scripts/src/master/userscripts/rue89.user.js) => greasemonkey script to restore legacy rue89 favicon
  * [clearvtigerloginform.user.js](https://forge.tourmentine.com/n/scripts/src/master/userscripts/clearvtigerloginform.user.js) => greasemonkey script to remove auto-filled login&password "admin" added by VTiger setup

Patches
-------

  * [alcasar_logo.patch](https://forge.tourmentine.com/n/scripts/src/master/alcasar_logo.patch) => small patch to add a background changer for ALCASAR webpages
  * [shaarli_OleG.0.9.0.patch](https://forge.tourmentine.com/n/scripts/src/master/shaarli_OleG.0.9.0.patch) => Open Graph support for Shaarli 0.9.X ( Hi [Charly](https://fr.wikipedia.org/wiki/Charly_Oleg)! ). no more necessary in Shaarli 0.10.0 and after

Monitoring
-------

  * [check_ntppool_score](https://forge.tourmentine.com/n/scripts/src/master/monitoring/check_ntppool_score) => Simple shell script to check score on NTP Pool Project (score must be over 10 to serve NTP). Requires Curl and bc, fits for Nagios/Shinken/Icinga/etc.
  * [collectd_ntppool_score](https://forge.tourmentine.com/n/scripts/src/master/monitoring/collectd_ntppool_score) => Same as [check_ntppool_score](https://forge.tourmentine.com/n/scripts/src/master/monitoring/check_ntppool_score) but for collectd graphing.
  * [check_postgresql_replication.sh](https://forge.tourmentine.com/n/scripts/src/master/monitoring/check_postgresql_replication.sh) => check postgresql's replication lag.
  * [check_rspamc](https://forge.tourmentine.com/n/scripts/src/master/monitoring/check_rspamc) => Check rspamd status. Heavily based on [check_spamc](https://www.vanheusden.com/Linux/check_spamc-0.1.tgz).
  * [GonKyrellM](https://forge.tourmentine.com/n/scripts/src/master/monitoring/GonKyrellM) => Conky, GKrellM style - with "invisible" theme (well, sort of)
  * [collectweather.sh](https://forge.tourmentine.com/n/scripts/src/master/monitoring/collectweather.sh) => get weather data from https://darksky.net/ and feed collectd with it. needs jq as Dark Sky provides data in json format.

Attic
-----

  * [73lab.sh](https://forge.tourmentine.com/n/scripts/src/master/attic/73lab.sh) => grap 73lab's wallpapers
  * [caminfo.sh](https://forge.tourmentine.com/n/scripts/src/master/attic/caminfo.sh) => update webcam info with xmms ouput
  * [caminit](https://forge.tourmentine.com/n/scripts/src/master/attic/caminit) => manage a very old webcam (Logitech Quickcam)
  * [kimsufi_postinstall.sh](https://forge.tourmentine.com/n/scripts/src/master/attic/kimsufi_postinstall.sh) => bootstrap script for fresh kimsufi/OVH servers
  * [mplayer_update.sh](https://forge.tourmentine.com/n/scripts/src/master/attic/mplayer_update.sh) => download, compile and install FFMpeg & MPlayer
  * [mkvig](https://forge.tourmentine.com/n/scripts/src/master/attic/mkvig) => little script to download covers
  * [tssh](https://forge.tourmentine.com/n/scripts/src/master/attic/tssh) => automaticaly rename Konsole tabs using ssh'ed hostname
  * [webnewsget2.sh](https://forge.tourmentine.com/n/scripts/src/master/attic/webnewsget2.sh)+[html2rss.php](https://forge.tourmentine.com/n/scripts/src/master/attic/html2rss.php) => download HTML pages and generate RSS feeds from them
  * [tsize.c](https://forge.tourmentine.com/n/scripts/src/master/attic/tsize.c) => small utility that displays a directory's size (yes, I basically rewrote DU(1)). original comments & bugs included, straight from the Millenium era

